/*
** Module   : MenuChuiImpl.java
** Abstract : CHUI client implementation of Menu.
**
** Copyright (c) 2005-2015, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- --JPRM-- -----------------------------Description-----------------------------
** 001 VIG 20150116          Created initial version.
*/
package com.goldencode.p2j.ui.client.chui;

import com.goldencode.p2j.ui.Color;
import com.goldencode.p2j.ui.MenuConfig;
import com.goldencode.p2j.ui.WidgetConfig;
import com.goldencode.p2j.ui.WidgetId;
import com.goldencode.p2j.ui.chui.ThinClient;
import com.goldencode.p2j.ui.client.Menu;
import com.goldencode.p2j.ui.client.MenuItem;
import com.goldencode.p2j.ui.client.Point;
import com.goldencode.p2j.ui.client.UiUtils;
import com.goldencode.p2j.ui.client.chui.driver.ChuiOutputManager;
import com.goldencode.p2j.ui.client.widget.Widget;

/**
 * <code>Menu</code> CHUI client implementation class. 
 */
public class MenuChuiImpl
extends Menu<ChuiOutputManager>
{
   /**
    * Special constructor used to restore component using given configuration.
    * 
    * @param   id
    *          The widget's ID.
    * @param   cfg
    *          Configuration data.
    */
   public MenuChuiImpl(WidgetId id, WidgetConfig cfg)
   {
      super(id, (MenuConfig) cfg);
   }

   /**
    * Draw the peer container. The methods calls the draw() method for
    * ScrollPane instance for the peer container. In addition the required
    * clipping rectangle is calculated for ChildFrame containers because they
    * must be rendered inside the parent container.
    * <p>
    * Drawing for the redirected terminal differs. Labels/headers are drawn
    * only once per page, instead of the usual once per frame.
    * 
    * @param   origin
    *          The coordinate of the upper-left corner for peer container in
    *          character units.
    * @param   size
    *          The size of the peer container in character units.
    */
   @Override
   public void draw()
   {
      ThinClient tc = ThinClient.getInstance();
      
      //Point p = location();
      Point p = new Point(0, 0);
      
      Color dColor = UiUtils.getDColor(this);
      
      //config().title
      
      for(Widget<ChuiOutputManager> w : widgets())
      {
         MenuItem mi = (MenuItem) w;
         screen().at(p).append(mi.config().title, dColor);
         p.x += mi.config().title.length() + 2;
      }
      
      
   }
}
